#ifndef DRAWING__H
#define DRAWING__H

#include "Shape.h"

class Drawing : public Shape
	{
	public:
		Drawing(int c=0, int r=0) : Shape(c, r, 0, 0), _first(0){}
		void add(Shape &sh);
		virtual Rectangle getContour();
		virtual char charAt(int i, int j);
		virtual ~Drawing();				//Destructor - Lschen der dynamisch erzeugten Liste (ShapeNode)

	private:
		class ShapeNode
			{
			friend Drawing;
			ShapeNode(Shape& sh) : _shape(sh), _next(0){}
			Shape& _shape;
			ShapeNode* _next;
			virtual ~ShapeNode(){}
			};
		ShapeNode *getLastNode();
		ShapeNode *_first;
	};

#endif